import java.awt.*;
import java.util.*;

public class Clock extends java.applet.Applet implements Runnable {

	Thread clockThread = null;
	Button bp,br;
	TextField tfm,tfs;
	int valorDecimal = 0,mTimer,sTimer,Timer=0,cont=0;
	boolean pausa;
	int hrs, min, seg;
	public void init() {							//En la funcion init se crean los botones y los campos
		bp = new Button( "PAUSA" );
	        br = new Button( "REINICIAR" );
		// Campo de texto vaco
	        tfm = new TextField( Integer.toString( valorDecimal ),3 );
        	// Campo de texto vaco con 20 columnas
	        tfs = new TextField( Integer.toString( valorDecimal ),3 );
		Label mEtiq = new Label( "Minutos:" );
	        Label sEtiq = new Label( "Segundos:" );
        	add( br );
		add(mEtiq);
        	add( tfm );
	        add(sEtiq);
        	add( tfs );
		add( bp );	
        }	


	public void start() {							//En la funcion start se encarga de inicializar el reloj
        	if (clockThread == null) {
            		clockThread = new Thread(this, "Clock");
            		clockThread.start();
            	}
	}
	
        public void run() {                               			//Hace funcionar el reloj
	// loop terminates when clockThread is set to null in stop()
		while (Thread.currentThread() == clockThread) {
        		repaint();
	            	try {
        	      		clockThread.sleep(1000);
            		} catch (InterruptedException e){}
		}
	}
	
//La funcion pain se encarga de mostrar los mensajes de texto
	public void paint(Graphics g) {						
		g.setColor(Color.blue);
		g.fillRect(0,0,500,150);                     //se pinta el fondo azul
		g.drawString("Tiempo Cumplido",200,100);
		g.setColor(Color.white);
		Date now = new Date();
		hrs= now.getHours();
		min = now.getMinutes();
		seg = now.getSeconds();
		g.drawString(hrs + ":" + min + ":" + seg, 200, 80);       //se pinta la fecha en letras blancas
		if(seg==15||seg==45)                                      //hace un beep a los 15 y 45 segundos
			System.out.print("\7");
		if(seg==30||seg==31)                                      //hace 2 beep a los 30 seg.
			System.out.print("\7");
		if(seg==0||seg==1||seg==2||seg==3)
			System.out.print("\7");                           //hace 4 beep al minuto.
		if(Timer!=0&&!pausa){
			g.drawString("Timer:"+((Timer-cont)/3600)+":"+((Timer-cont)/60)+":"+(Timer-cont),180,100); //pinta el conteo del timer
			cont++;
			if(Timer==cont){                                                                                    //avisa del tiempo cumplido del timer
				g.setColor(Color.blue);
				g.drawString("Timer:"+((Timer-cont)/3600)+":"+((Timer-cont)/60)+":"+(Timer-cont),180,100);
			        g.setColor(Color.white);
				g.drawString("Tiempo Cumplido",200,100);
				System.out.print("tiempo cumplido"+"\7\n");
				cont=0;
				Timer=0;
			}
		}
		
	}
	
	public void stop() {
        	clockThread = null;
	}

//se encarga de los evenos en el panel
	public boolean action( Event evt,Object obj ) {
        	if( evt.target instanceof TextField ){
			if( evt.target.equals( tfm ) )
        	        	System.out.println( "Debe ingresar los segundos\n " );
			if( evt.target.equals( tfs ) )
                		mTimer = Integer.parseInt( tfm.getText() );                         //almacena os valores de los minutos y segundos del timer
				sTimer = Integer.parseInt( tfs.getText() );
				System.out.println("Timer: min "+mTimer+"    seg "+sTimer+"\n");
				Timer=mTimer*60+sTimer;
		}
		if( evt.target.equals( bp ) )                                                 // setea la variable que imdica pausa cuando corresponde
			if(Timer!=0){
				System.out.println( "Timer en pausa\n" );
				pausa = true;
			}
        	if( evt.target.equals( br ) )
            		if(Timer!=0){
				System.out.println( "Se ha reiniciado Timer\n" );
				pausa = false;
			}
        return true;
        }


}

